VERSION 2.00
Begin Form Browser 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Browser"
   ClientHeight    =   2892
   ClientLeft      =   5580
   ClientTop       =   1776
   ClientWidth     =   4752
   Height          =   3264
   Icon            =   BROWSER.FRX:0000
   Left            =   5532
   LinkTopic       =   "Form1"
   ScaleHeight     =   241
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   396
   Top             =   1452
   Width           =   4848
   Begin ListBox List1 
      DragIcon        =   BROWSER.FRX:0302
      Height          =   3864
      Left            =   120
      MultiSelect     =   2  'Extended
      TabIndex        =   2
      Top             =   480
      Width           =   5772
   End
   Begin CommandButton copy 
      BackColor       =   &H00000000&
      Caption         =   "&Copy"
      Height          =   288
      Left            =   2880
      TabIndex        =   1
      Top             =   120
      Width           =   1572
   End
   Begin TextBox Text1 
      Height          =   288
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1332
   End
   Begin Line l 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   2
      Index           =   1
      X1              =   0
      X2              =   220
      Y1              =   1
      Y2              =   1
   End
   Begin Line l 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   2
      Index           =   0
      X1              =   1
      X2              =   1
      Y1              =   0
      Y2              =   300
   End
   Begin Line l 
      BorderColor     =   &H00808080&
      BorderWidth     =   2
      Index           =   3
      X1              =   0
      X2              =   100
      Y1              =   150
      Y2              =   150
   End
   Begin Line l 
      BorderColor     =   &H00808080&
      BorderWidth     =   2
      Index           =   2
      X1              =   360
      X2              =   360
      Y1              =   0
      Y2              =   110
   End
End
Option Explicit
Option Compare Text
Dim pasting%
Dim r%

Sub copy_Click ()
'copy selections to clipboard
Dim s$, i%, prefix$, total%
Dim buf$, char1%, char2%
'
On Error GoTo lerr
'
'build a string of all selected items
total% = SendMessage(List1.hWnd, LB_GETSELCOUNT, 0, 0&)
If total% > 0 Then
    prefix$ = text1.Tag
    buf$ = String(total% * 2, " ")
    r% = SendMessage(List1.hWnd, LB_GETSELITEMS, total%, ByVal buf$)
    i% = 1
    Do While i% < Len(buf$)'total%
        char1 = Asc((Mid$(buf$, i%, 1)))
        char2 = Asc((Mid$(buf$, i% + 1, 1)))
        s$ = s$ & prefix$ & " " & List1.List(char1 + char2 * &H100) & nl
        i% = i% + 2
    Loop
    clipboard.SetText s$
    i% = List1.TopIndex
    List1.ListIndex = -1
    List1.TopIndex = i%
End If

Exit Sub

lerr:
MsgBox "Err: " & Err & nl & Error(Err), , "browser"
Exit Sub

End Sub

Sub Form_MouseUp (Button As Integer, Shift As Integer, X As Single, Y As Single)
'end a drag/drop; paste list selections into a code window
If Not pasting% Then Exit Sub

Dim p As pointAPI, hWnd%, temp&, s$, txt$, n%
Dim t$, checkdest$
t$ = String(255, " ")

'get screen pnt., release capture
p.X = X
p.Y = Y
ClientToScreen Me.hWnd, p
r% = GetCursor(CInt(Me.hWnd), 2)
ReleaseCapture
pasting% = 0

'convert pointapi to long:
temp& = p.X + CLng(p.Y) * &H10000

'get window handle the dec's were dropped on
hWnd% = WindowFromPointByNum%(temp&)
If hWnd% = 0 Then Beep: Exit Sub
'
'bump up to the parent if the combobox, etc. were clicked
txt$ = String(32, " ")
s$ = Left$(txt$, GetClassName(hWnd%, txt$, Len(txt$)))
Debug.Print "pasting:first=" & Hex(hWnd) & " " & s$
If s$ <> "OEBDebug" Then
    Do While n% < 3
        hWnd% = GetParent(hWnd%)
        n% = n% + 1
        s$ = Left$(txt$, GetClassName(hWnd%, txt$, Len(txt$)))
        If s$ = "OEBDebug" Then Exit Do
    Loop
End If
If hWnd = 0 Then Exit Sub
'
'check the window to see if anything is selected.
'we must refuse to paste if so, because this situation
'is too dangerous
    'fetch any selected text from the active window
    clipboard.Clear
    r% = SendMessage(hWnd%, WM_COPY, 0, 0&)
    checkdest$ = Trim$(clipboard.GetText(1))
    If checkdest$ <> "" Then
        MsgBox "Deselect all text in the destination window and set the insertion point to place you want to paste the declarations. Then drop the files again.", 16, "OVERWRITE WARNING!"
        Exit Sub
    End If

'copy to clip
copy_Click
r% = DoEvents()

'tell the window to paste from clip
r% = SendMessage(hWnd%, WM_PASTE, 0, 0&)
r% = DoEvents()
End Sub

Sub Form_Paint ()
sink Me, List1
sink Me, text1
End Sub

Sub Form_Resize ()
Dim w%, h%
w = List1.Width: h = List1.Height
If Width > 3240 Then
    w = scaleWidth - 16
    copy.Move w + 10 - copy.Width
End If
If Height > 1605 Then h = scaleHeight - 50
List1.Move List1.Left, List1.Top, w, h
ResizeLines Me
End Sub

Sub Form_Unload (Cancel As Integer)
'notify the array procedure that this is unloaded
r% = LoadBrowser("", CStr(Caption), "", Val(Tag))
End Sub

Sub List1_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'begin a drag/drop operation
If Button = 2 Then
    '
    'see if any items are selected
    If (SendMessage(List1.hWnd, LB_GETSELCOUNT, 0, 0&) > 0) Then
        pasting = -1
        r = SetCapture(Me.hWnd)
        r% = GetCursor(CInt(Me.hWnd), 4)
    End If
End If
End Sub

Sub Text1_Change ()
Dim i%, t$, lng%, ndx%, s$, r%

'jump to nearest item
t$ = Trim$(text1): lng% = Len(t$)
If lng% = 0 Or List1.ListCount = 0 Then Exit Sub
'
Do
If StrComp(Left$(List1.List(ndx), 1), Left(t$, 1)) > -1 Then
   ndx = ndx - 20
   If ndx < 0 Then ndx = 0
   Exit Do
End If
ndx = ndx + 20
If ndx > List1.ListCount - 1 Then ndx = List1.ListCount - 1: Exit Do
Loop
For i = ndx To List1.ListCount - 1
   s$ = Left$(List1.List(i), lng)
   r% = StrComp(s$, t$)
   If r >= 0 Then List1.TopIndex = i: Exit Sub
Next
List1.TopIndex = i - 1
End Sub

