VERSION 2.00
Begin Form frmSeq 
   Caption         =   "VB Sequencer"
   ClientHeight    =   3375
   ClientLeft      =   390
   ClientTop       =   1950
   ClientWidth     =   5580
   Height          =   4065
   Icon            =   INCL.FRX:0000
   Left            =   330
   LinkTopic       =   "Form1"
   ScaleHeight     =   3375
   ScaleWidth      =   5580
   Top             =   1320
   Width           =   5700
   Begin TextBox TabWidth 
      Enabled         =   0   'False
      Height          =   285
      Left            =   4800
      TabIndex        =   4
      Text            =   "4"
      Top             =   1800
      Width           =   375
   End
   Begin CheckBox ckTabsToSpaces 
      Caption         =   "Convert Tabs to Spaces"
      Height          =   255
      Left            =   600
      TabIndex        =   3
      Top             =   1800
      Width           =   2415
   End
   Begin TextBox Incr 
      Height          =   285
      Left            =   3360
      TabIndex        =   6
      Top             =   2280
      Width           =   855
   End
   Begin TextBox fromLineNo 
      Height          =   285
      Left            =   1200
      TabIndex        =   5
      Top             =   2280
      Width           =   1575
   End
   Begin CommonDialog cmddlgFiles 
      DialogTitle     =   "File Selection"
      Filter          =   "*.bas"
      InitDir         =   "C:\"
      Left            =   4680
      Top             =   1080
   End
   Begin TextBox FileName 
      Height          =   285
      Left            =   600
      TabIndex        =   0
      Top             =   240
      Width           =   4575
   End
   Begin OptionButton optRemSeq 
      Caption         =   "&Remove Sequence Numbers"
      Height          =   255
      Left            =   1320
      TabIndex        =   2
      Top             =   1200
      Width           =   2775
   End
   Begin OptionButton optAddSeq 
      Caption         =   "&Add Sequence Numbers"
      Height          =   255
      Left            =   1320
      TabIndex        =   1
      Top             =   840
      Width           =   2655
   End
   Begin CommandButton pbCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2880
      TabIndex        =   8
      Top             =   2760
      Width           =   1575
   End
   Begin CommandButton pbProceed 
      Caption         =   "&Proceed"
      Default         =   -1  'True
      Height          =   375
      Left            =   960
      TabIndex        =   7
      Top             =   2760
      Width           =   1575
   End
   Begin Frame Frame1 
      Height          =   975
      Left            =   1200
      TabIndex        =   9
      Top             =   600
      Width           =   3015
   End
   Begin Label Label4 
      Caption         =   "Tab Stop Width"
      Height          =   255
      Left            =   3360
      TabIndex        =   13
      Top             =   1800
      Width           =   1455
   End
   Begin Label Label3 
      Caption         =   "File"
      Height          =   255
      Left            =   240
      TabIndex        =   12
      Top             =   240
      Width           =   375
   End
   Begin Label Label2 
      Caption         =   "Incr"
      Height          =   255
      Left            =   3000
      TabIndex        =   11
      Top             =   2280
      Width           =   375
   End
   Begin Label Label1 
      Caption         =   "From Line#"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   2280
      Width           =   975
   End
   Begin Menu FileOpn 
      Caption         =   "&File"
      Begin Menu FileOpen 
         Caption         =   "&Open"
      End
      Begin Menu FileExit 
         Caption         =   "E&xit"
      End
   End
End
Option Explicit

Sub AddRemSeq (pPlusOrMinus$)
    Dim fNum%, fOut%, ALine$, mErr%, mIamIn%, AOrigLine$, ATmpLine$, mChg%, mTmp$
    Dim pItm1$, pItm2$, pItm3$, pItm4$
    Dim mCnt1%, mLineFrom&, mIncr%, mFoundCnt&
    mFoundCnt = 0
    mLineFrom = frmSeq!fromLineNo
    mIncr = frmSeq!Incr
    fNum = FreeFile
    Open frmSeq!FileName For Input As #fNum
    mTmp = Cre_Tmp_File("C:\", "_VBSQ", "", "TMP", 0)
    fOut = FreeFile
    Open mTmp For Output As #fOut
    mErr = False
    mIamIn = False
    Do Until EOF(fNum)
        DoEvents
        mChg = False
        Line Input #fNum, AOrigLine
        ' FF is also used as spaces.
        ALine = strtran(AOrigLine, Chr$(255), " ")
        ' Strip backspace character
        ALine = strtran(ALine, Chr$(8), "")
        ALine = strtran(ALine, Chr$(9), Space(frmSeq!TabWidth))
        If frmSeq!ckTabsToSpaces = "1" Then
            AOrigLine = ALine
        End If
        ALine = Trim(ALine)
        ' Remove multiple spaces to just one.
        Do While True
            If InStr(1, ALine, "  ") > 0 Then
                ALine = strtran(ALine, "  ", " ")
            Else
                Exit Do
            End If
        Loop
        pItm1 = UCase(Parse_For_Value(ALine, 1, " "))
        pItm2 = UCase(Parse_For_Value(ALine, 2, " "))
        pItm3 = UCase(Parse_For_Value(ALine, 3, " "))
        pItm4 = UCase(Parse_For_Value(ALine, 4, " "))
        If (Left(pItm1, 1) = "'") Or (Left(pItm1, 3) = "REM") Then
            'Comments
            GoTo AddRemSeq_Skip1
        End If
        ' How about labels
        If Right(pItm1, 1) = ":" Then
            GoTo AddRemSeq_Skip1
        End If
        ' Remove sequence number if it is there
        If IsNumeric(pItm1) Then
            ' Shift all the parameters
            pItm1 = pItm2
            pItm2 = pItm3
            pItm3 = pItm4
            pItm4 = ""
        End If
        If (pItm1 = "STATIC" And pItm2 = "PRIVATE") And (pItm3 = "FUNCTION" Or pItm3 = "FUNCTION(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "PRIVATE" And (pItm2 = "FUNCTION" Or pItm2 = "FUNCTION(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "STATIC" And (pItm2 = "FUNCTION" Or pItm2 = "FUNCTION(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If
        If (pItm1 = "FUNCTION" Or pItm1 = "FUNCTION(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If

        ' Now check for Sub
        If (pItm1 = "STATIC" And pItm2 = "PRIVATE") And (pItm3 = "SUB" Or pItm3 = "SUB(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "PRIVATE" And (pItm2 = "SUB" Or pItm2 = "SUB(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "STATIC" And (pItm2 = "SUB" Or pItm2 = "SUB(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If

        If (pItm1 = "SUB" Or pItm1 = "SUB(") Then
            mIamIn = True
            GoTo AddRemSeq_Skip1
        End If

        ' Now check for End Function etc.
        If pItm1 = "END" And pItm2 = "FUNCTION" Then
            mIamIn = False
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "END" And pItm2 = "SUB" Then
            mIamIn = False
            GoTo AddRemSeq_Skip1
        End If
        
        If pItm1 = "SELECT" And pItm2 = "CASE" Then
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "END" And pItm2 = "SELECT" Then
            GoTo AddRemSeq_Skip1
        End If
        If pItm1 = "CASE" Then
            GoTo AddRemSeq_Skip1
        End If
        mChg = True
AddRemSeq_Skip1:
        If mIamIn And mChg Then
            ' Line needs to be fixed. Lets remove a sequence number if it was there.
            mFoundCnt = mFoundCnt + 1
            ATmpLine = strtran(AOrigLine, Chr(255), " ")
            ATmpLine = strtran(ATmpLine, Chr(9), Space(frmSeq!TabWidth))
            ATmpLine = strtran(ATmpLine, Chr(8), "")
            ' At this point ATmpLine is almost as good as the original.
            ALine = LTrim(ATmpLine)
            
            mCnt1 = Len(ATmpLine) - Len(ALine)
            If IsNumeric(Parse_For_Value(ALine, 1, " ")) Then
                ' There is a sequence number here. Lets remove it.
                ALine = Mid(ATmpLine, mCnt1 + Len(Parse_For_Value(ALine, 1, " ")) + 1)
            Else
                ' There are no sequence numbers.
                ALine = AOrigLine
            End If
            If pPlusOrMinus = "+" Then
               ALine = Format(mLineFrom, "00000") & ALine
               mLineFrom = mLineFrom + mIncr
               If mLineFrom > 65529 Then
                   MsgBox "Line numbers overflowed (>65529)"
                   mErr = True
                   Exit Do
               End If
            End If
        Else
            ALine = AOrigLine
        End If
        ' Lets write the line.
        Print #fOut, ALine
    Loop
    Close #fNum
    Close #fOut
    If mFoundCnt = 0 Then
        MsgBox ("This file does not need any conversion.")
    End If
    If mErr Or mFoundCnt = 0 Then
        Kill mTmp
        GoTo AddRemSeq_Exit
    End If
    ' Now rename the temp file.
    frmSeq!cmddlgFiles.DialogTitle = "Save Output As"
    Do While True
        frmSeq!cmddlgFiles.Action = 1
        If frmSeq!cmddlgFiles.FileName <> "" Then
            If Dir$(frmSeq!cmddlgFiles.FileName, ATTR_NORMAL) <> "" Then
                If MsgBox("File " & frmSeq!cmddlgFiles.FileName & " exists overwrite it?", MB_ICONSTOP + MB_YESNO) = IDYES Then
                    Kill frmSeq!cmddlgFiles.FileName
                    FileCopy mTmp, frmSeq!cmddlgFiles.FileName
                    Kill mTmp
                    MsgBox "Done!"
                    GoTo AddRemSeq_Exit
                End If
            Else
                FileCopy mTmp, frmSeq!cmddlgFiles.FileName
                Kill mTmp
                MsgBox "Done!"
                GoTo AddRemSeq_Exit
            End If
        Else
            Kill mTmp
            GoTo AddRemSeq_Exit
        End If
    Loop
AddRemSeq_Exit:
    Exit Sub
End Sub

Sub ckTabsToSpaces_Click ()
    If frmSeq!ckTabsToSpaces = "0" Then
        frmSeq!TabWidth = 4
        frmSeq!TabWidth.Enabled = False
    Else
        frmSeq!TabWidth.Enabled = True
    End If
End Sub

Sub EvalValues ()
     If frmSeq!optAddSeq Then
         frmSeq!fromLineNo.Enabled = True
         If frmSeq!fromLineNo = "" Then
             frmSeq!fromLineNo = "10000"
         End If
         frmSeq!Incr.Enabled = True
         If frmSeq!Incr = "" Then
            frmSeq!Incr = 10
         End If
     Else
        frmSeq!fromLineNo.Enabled = False
        frmSeq!Incr.Enabled = False
     End If
     If (Trim(frmSeq!FileName) = "") Or ((Not frmSeq!optAddSeq) And (Not frmSeq!optRemSeq)) Then
        frmSeq!pbProceed.Enabled = False
     Else
        frmSeq!pbProceed.Enabled = True
     End If
End Sub

Sub FileExit_Click ()
    End
End Sub

Sub FileName_Change ()
    EvalValues
End Sub

Sub FileOpen_Click ()
    frmSeq!cmddlgFiles.Action = 1
    If frmSeq!cmddlgFiles.FileName <> "" Then
        frmSeq!FileName = frmSeq!cmddlgFiles.FileName
        EvalValues
    End If
End Sub

Sub Form_Load ()
    EvalValues
    frmSeq!optAddSeq = True
    frmSeq!cmddlgFiles.Filter = "Basic Programs (*.bas)|*.bas|All files (*.*)|*.*"
    frmSeq!cmddlgFiles.InitDir = "C:\"
    frmSeq!cmddlgFiles.DefaultExt = "*.bas"
End Sub

Sub optAddSeq_Click ()
    EvalValues
End Sub

Sub optRemSeq_Click ()
    EvalValues
End Sub

Sub pbCancel_Click ()
    End
End Sub

Sub pbProceed_Click ()
    If Dir$(frmSeq!FileName, ATTR_NORMAL) = "" Then
        MsgBox "Input file " & frmSeq!FileName & " not found"
        Exit Sub
    End If
    If (Not IsNumeric(frmSeq!fromLineNo)) Or (Not IsNumeric(frmSeq!Incr)) Then
        MsgBox "From Line# and/or Incr not numeric"
        Exit Sub
    End If
    If (Not IsNumeric(frmSeq!TabWidth)) And (frmSeq!ckTabsToSpaces = "1") Then
        MsgBox "Tab Width must be numeric"
        Exit Sub
    End If
    If (frmSeq!optAddSeq) Then
        If Trim(frmSeq!fromLineNo) = "" Or Trim(frmSeq!Incr) = "" Then
            MsgBox "From Line# and increment must be supplied"
            Exit Sub
        End If
    End If
    If (frmSeq!fromLineNo = 0) And (frmSeq.optAddSeq) Then
        MsgBox "From Line# must be > 0"
        Exit Sub
    End If
    If (frmSeq!Incr > 100) And (frmSeq.optAddSeq) Then
        MsgBox "Increment must be <= 100"
        Exit Sub
    End If
    If (frmSeq!fromLineNo > 65529) And (frmSeq.optAddSeq) Then
        MsgBox "From Line# must be <= 65529"
        Exit Sub
    End If
    If ((frmSeq!TabWidth > 8) And (frmSeq!ckTabsToSpaces = "1")) Or ((frmSeq!TabWidth < 1) And (frmSeq!ckTabsToSpaces = "1")) Then
        MsgBox "Tab Width must be within 1 and 8 spaces. (Default 4)"
        Exit Sub
    End If
    If frmSeq!optAddSeq Then
        AddRemSeq "+"
    Else
        AddRemSeq "-"
    End If
End Sub

