Global Const true = -1
Global Const false = 0

'---------------------------------------------------------
'---------------------------------------------------------
'
'            HLLAPI constants
'
'--------------------------------------------------------
'
' Standard return codes:
'

Global Const Good = 0
Global Const InvalidPS = 1 ' ask for "B" and only "A" available
Global Const ParameterError = 2 ' or maybe an invalid function was called
Global Const WSerror = 3 ' not used in windows
Global Const Busy = 4  ' system in XCLOCK or XSYSTEM
Global Const BusyOther = 5
Global Const DataError = 6 ' invalid parameter (truncated?, conversion?)
Global Const InvalidPSPosition = 7 ' not a valid screen location
Global Const ProcedureError = 8  ' missing prerequisite function ...
Global Const SystemError = 9  ' serious error
Global Const FunctionNotAvailable = 10 ' at least not in this release
Global Const ResourceUnavailable = 11 ' for example: exceeded maximum of 12 sessions


'---------------------------------------------------------
'
' Special key definitions used by SendKey and
' returned by GetKey
'

Global Const ALT = "@A"
Global Const BackTab = "@B"
Global Const ClearScreen = "@C"
Global Const DelChar = "@D"
Global Const Enter = "@E"
Global Const EraseEOF = "@F"
Global Const Help = "@H"
Global Const Insert = "@I"
Global Const Jump = "@J"
Global Const Copy = "@K"
Global Const CursorLeft = "@L"
Global Const Enlarge = "@M"
Global Const NewLine = "@N"
Global Const PrintScreen = "@P"
Global Const Quit = "@Q"
Global Const ResetKeyBoard = "@R"
Global Const Shift = "@S"
Global Const ForwardTab = "@T"
Global Const CursorUp = "@U"
Global Const CursorDown = "@V"
Global Const Reserved = "@X"
Global Const CapsLock = "@Y"
Global Const CursorRight = "@Z"
Global Const BackSpace = "@<"
Global Const Home = "@0"
Global Const PF1 = "@1"
Global Const PF2 = "@2"
Global Const PF3 = "@3"
Global Const PF4 = "@4"
Global Const PF5 = "@5"
Global Const PF6 = "@6"
Global Const PF7 = "@7"
Global Const PF8 = "@8"
Global Const PF9 = "@9"
Global Const PF10 = "@a"
Global Const PF11 = "@b"
Global Const PF12 = "@c"
Global Const PF13 = "@d"
Global Const PF14 = "@e"
Global Const PF15 = "@f"
Global Const PF16 = "@g"
Global Const PF17 = "@h"
Global Const PF18 = "@i"
Global Const PF19 = "@j"
Global Const PF20 = "@k"
Global Const PF21 = "@l"
Global Const PF22 = "@m"
Global Const PF23 = "@n"
Global Const PF24 = "@o"
Global Const PA1 = "@x"
Global Const PA2 = "@y"
Global Const PA3 = "@z"
Global Const AtSign = "@@"



